#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

// Simulated Annealing


#define	HIVAL	999999999999999999999.

#define	MAXNODES	500
#define	DIMGRID		5000
#define	K			2//4

#define TOLL		0.00001

// Settaggio BIP buono
#define TOLL2		0.00001
#define SAINIT		0.00002 
#define NUMITER		30000
#define QUOZIENTE	1.112

// Ripetizioni
#define	REP			1

// SA
#define B	        10000.

#define bool 	short
#define true	1
#define false	0

struct coord
{
	double x;
	double y;
};

struct snodi
{
	int x;
	int y;
};

int fatto[MAXNODES];
int nfatto;
int livello;
int toaddd;
int ordinevertici[MAXNODES];
double inittime,tottime,tottime2,parttime;
struct coord nodi[MAXNODES];
struct snodi pred[MAXNODES][MAXNODES];
int	ord[MAXNODES][MAXNODES];
int	invord[MAXNODES][MAXNODES];
double dist[MAXNODES][MAXNODES];
double coeff[MAXNODES][MAXNODES]; /* This can be overwritten on dist maybe */
bool best[MAXNODES][MAXNODES];
bool dafare[MAXNODES][MAXNODES];
double sub,tub,bestub,ub;
int level;
int n;

int mp[MAXNODES];
bool sol[MAXNODES][MAXNODES];
bool bestsol[MAXNODES][MAXNODES];
int raga[MAXNODES];
int nraga;
int ragda[MAXNODES];


/* Prim */
	int u[MAXNODES];
	struct snodi e[MAXNODES];
	int alfa[MAXNODES];
	double beta[MAXNODES];
	int x[MAXNODES];
	int ne,nu,nx;
/* Fine Prim */

/* Lagrange */
	bool cavarevincoli;
	double nu1[MAXNODES][MAXNODES], nu2[MAXNODES][MAXNODES];
	double bestnu1[MAXNODES][MAXNODES], bestnu2[MAXNODES][MAXNODES];
	int y[MAXNODES][MAXNODES];
	double realy[MAXNODES][MAXNODES];
	int z[MAXNODES][MAXNODES];
/* Fine Lagrange */

	double temp;

void SteepestDescent();
bool Buchi();
void ModificaPen();
void Lagrange();
void CalcolaCoeff();
int SelectNode();
void Branch_Bound();
void AllineaLB();
double CalcLB();
bool SolInt();
void CreaRete();
void Semplifica();
void Formula1sim();
void CreaOrd();
void CreaProb();
void CalcolaDist();
bool Prim();
void Esatto();
void CalcolaUB2();
void Branch();
void WorkCPLEX();
void SimulatedAnnealing_1();
void CreateCPLEX();
void CreateCPLEX2();
void CloseCPLEX();
void SolveCPLEX();
void AddCtrCPLEX();
void AddCtrCPLEX2();
void AggiungiCPLEX();
void TogliCPLEX();
void OrdinaVertici();
void DAS();
double Cost();

void Raggiungib(int k,int kk)
{
	int i,j,old,ff;
	
	for(i=0;i<n;ragda[i++]=0);
	ff=-14;
	raga[0]=0;
	if(0==k)
		ff=0;
	ragda[0]=1;
	nraga=1;
	old=0;	
	for(j=old;j<nraga;j++)
		for(i=0;i<n;i++)
			if(!ragda[i] && sol[raga[j]][i] && dafare[i][kk])
			{
				if(i==k)
					ff=nraga;
				ragda[i]=1;
				raga[nraga++]=i;					
			}
	if(ff!=-14)
		raga[ff]=raga[--nraga];
}

void Raggiungic(int k)
{
	int i,j,old,ff;
	
	for(i=0;i<n;ragda[i++]=0);
	raga[0]=k;
	ragda[k]=1;
	nraga=1;
	old=0;	
	for(j=old;j<nraga;j++)
		for(i=0;i<n;i++)
			if(!ragda[i] && sol[raga[j]][i])
			{
				ragda[i]=1;
				raga[nraga++]=i;					
			}
}

void BIP()
{
	int i,j,k,ntodo,minx,miny;
	double x,valmin;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			sol[i][j]=0;

	for(i=0;i<n;i++)
		mp[i]=-14;

	mp[0]=1;
	for(i=2;i<n;i++)
		if(dist[0][i]<dist[0][mp[0]])
			mp[0]=i;
	mp[mp[0]]=-1;
	sol[0][mp[0]]=1;
	ntodo=n-2;

	//printf("Inserisco %d %d\n",0,mp[0]);
	while(ntodo)
	{
		valmin=HIVAL;
		for(i=0;i<n;i++)
			if(mp[i]>=-1)
			{			
				for(j=0;j<n;j++)
					if(mp[j]<-1)
					{
						x=dist[i][j];
						if(mp[i]>-1)
							x-=dist[i][mp[i]];
						if(x<valmin)		
						{
							valmin=x;
							minx=i;
							miny=j;
						}
					}
			}
		//printf("Inserisco %d %d\n",minx,miny);
		if(dist[minx][mp[minx]]<dist[minx][miny])
			mp[minx]=miny;
		mp[miny]=-1;
		sol[minx][miny]=1;
		ntodo--;
	}

	{
		int i,j;

		for(i=0;i<n;i++)
			for(j=0;j<n;j++)
			{
				bestsol[i][j]=sol[i][j];
				//printf("%d %d=%d (%f)\n",i,j,sol[i][j],dist[i][j]);
			}
	}
	/*
	valmin=0.;
	for(i=0;i<n;i++)
		if(mp[i]>=0)
		{
			valmin+=dist[i][mp[i]];
			printf("%d %d %f\n",i,mp[i],dist[i][mp[i]]);
		}

	printf("cost ipotetico BIP: %f\n",valmin);
	*/
	valmin=Cost();
	//printf("cost BIP: %f\n",valmin);		
	ub=valmin;
}

void STG()
// Stochastic tree generation
{
	int i,j,k,m,l,o,minx,miny;
	int foglie[MAXNODES],nfoglie,todo[MAXNODES],ntodo;
	double x,valmin;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			sol[i][j]=0;

	for(i=0;i<n;i++)
	{
		mp[i]=-14;
		todo[i]=i;
	}
	ntodo=n;

	mp[0]=-2;
	todo[0]=todo[--ntodo];
	foglie[0]=0;
	nfoglie=1;

	for(i=0;ntodo>0;i++)
	{
		k=foglie[j=rand()%nfoglie];
		foglie[j]=foglie[--nfoglie];
		
		if(nfoglie>0)
			todo[ntodo++]=k;
		
		l=todo[m=rand()%ntodo];
		if(nfoglie>0 && m<ntodo-1)
			todo[--ntodo];
		
		if(l==k)
		{
			todo[m]=todo[--ntodo];
			mp[k]=-1;
		}
		else
		{
			for(o=0;o<ntodo;o++)
				if(dist[k][todo[o]]<=dist[k][l])
			{
				bestsol[k][todo[o]]=sol[k][todo[o]]=1;
				foglie[nfoglie++]=todo[o];
				mp[todo[o]]=-2;
				todo[o]=todo[--ntodo];
				o--;
			}
			mp[k]=invord[k][l];
		}
	}

	for(i=0;i<n;i++)
	{
		if(mp[i]==-2)
			mp[i]=-1;
		for(j=0;j<n;j++)
			if(mp[i]>=0 && dist[i][j]<=dist[i][mp[i]])
				sol[i][j]=bestsol[i][j]=1;
	}

	valmin=Cost();
	ub=valmin;
	printf("cost STG: %f\n",valmin);		
}

void Sweep()
{
	int i,j,contatore=0,ii,jj,k;
	int max1,max2;
	bool tr=1;
	double valmin;

	while(tr)
	{
		tr=0;
		for(i=0;i<n;i++)
			if(mp[i]>-1)
			{
					Raggiungic(i);
					for(j=0;j<nraga;j++)
						if(dist[i][raga[j]]<dist[i][mp[i]] && dist[raga[j]][mp[i]]<dist[raga[j]][mp[raga[j]]])
						{
							tr=1;
							ii=-14;
							//printf("Fotto %d %d %f\n",i,mp[i],dist[i][mp[i]]);
							sol[i][mp[i]]=0;
							sol[raga[j]][mp[i]]=1;
							//printf("copro con %d %d %f\n",raga[j],mp[i],dist[raga[j]][mp[i]]);
							for(k=0;k<n;k++)
								if((ii==-14 && sol[i][k]) || (sol[i][k] && dist[i][k]>dist[i][ii]))
									ii=k;
							mp[i]=ii;
							//printf("nuovo limite %d %d %f\n",i,mp[i],dist[i][mp[i]]);
						}
			}
	}

	
	valmin=0.;
	for(i=0;i<n;i++)
	{
		if(mp[i]==-14)
			printf("Disastro\n");
		if(mp[i]>-1)
			valmin+=dist[i][mp[i]];
	}
	//printf("cost Sweep: %f\n",valmin);
	ub=valmin;
}

void SimulatedAnnealing_1()
{
 	int i,j,jj,l,k,kk,kkk,oldi,oldj,conta;

	double oldub=ub;

	temp=SAINIT;
	tub=bestub=ub;

	conta=0;
	
 	while(temp>TOLL2)
 	{
		conta++;
		
		if(conta>=NUMITER)
		{
			conta=0;
			temp/=QUOZIENTE;
		}

		// Salta k!
 		for(k=rand()%n,l=0;l<n && mp[k]<0;l++,k=((k+1)%n));

		/*
		if(l==n)
		{
			for(k=0;k<n;k++)
				printf("%d ",mp[k]);
			getchar();
		}
		*/

		sol[k][kk=mp[k]]=0;
		//printf("Tolgo %d %d\n",k,kk);
		// Risistemo k
		tub-=dist[k][kk];
		mp[k]=-14;
		for(l=0;l<n;l++)
		{
 			if(l!=k && sol[k][l] && (mp[k]==-14 || dist[k][mp[k]]<dist[k][l]))
				mp[k]=l; 		
		}
		if(mp[k]!=-14)
			tub+=dist[k][mp[k]];

		Raggiungib(k,kk); 
		
		if(nraga==n)
			printf("Beccato\n"),getchar();
		if(nraga==0)
		{
		//	printf("Rigetto\n");
			goto rigettiamo;
		}
		//else
		//	printf("NON Rigetto\n");

		if((rand()%1000)<800)
		{
			double pago,pago2;
			i=-14;
			pago=HIVAL;
			for(j=0;j<nraga;j++)
				if(raga[j]!=k)
				{
					pago2=dist[raga[j]][kk];
					if(mp[raga[j]]!=-14)
						pago2-=dist[raga[j]][mp[raga[j]]];
					if(pago>pago2)
					{
						pago=pago2;
						i=raga[j];
					}
				}
			if(i==-14)
				printf("Vaffanculo\n"),getchar();
		}	
		else
			i=raga[rand()%nraga];	

		oldi=mp[i];
		
		if(mp[i]==-14 || dist[i][kk] > dist[i][mp[i]])
		{		
			if(mp[i]!=-14)
				tub-=dist[i][mp[i]];
			mp[i]=kk;
			tub+=dist[i][kk];
		}		
		//printf("Metto %d %d\n",i,kk);
		//printf("Propongo %d-%d to %d-%d\n",k,kk,i,kk);
		//printf("Costo: %f %f %f\n",tub,ub,bestub);		
		if(tub<ub || ((rand()%1000)/1000.<exp(-(tub-ub)/(temp*B))))
		{
			//printf("Accepted\n");
			// Accepted

			{
				int ij;

				for(ij=0;ij<n;ij++)
					if(i!=ij && dist[i][ij]<dist[i][kk])
						sol[i][ij]=1;
			}
			sol[i][kk]=1;
			if(mp[i]==-14 || sol[i][mp[i]]<sol[i][kk])
				mp[i]=kk;
			if(mp[k]==-14)
				mp[k]=-1;
			ub=tub;
			if(tub<bestub-TOLL)
			{
				parttime=clock();
				conta=0;
				bestub=tub;
				{
					int i,j;

					for(i=0;i<n;i++)
						for(j=0;j<n;j++)
							bestsol[i][j]=sol[i][j];
				}
				//printf("Found %f\n",tub);
			}
//			for(i=0;i<n;i++,printf(" A\n"))
//		for(j=0;j<n;j++)
//			printf("%d ",sol[i][j]);
		}
		else
		{
			mp[i]=oldi;
rigettiamo:
			// Rejected
			//printf("Rejected\n");
			tub=ub;
			mp[k]=kk;
			sol[k][kk]=1;
//for(i=0;i<n;i++,printf(" R\n"))
//		for(j=0;j<n;j++)
//			printf("%d ",sol[i][j]);
		}
 	}
	//printf("Improvement: %f \n",(oldub-bestub)/oldub);
}

void BuildInitSol()
{
	int j,i;
	
	ub=0.;
	for(j=0;j<n;j++)
	{
		mp[j]=-14;
		for(i=0;i<n;i++)
			sol[j][i]=0;
	}

	for(i=0;i<ne;i++)
	{
		sol[e[i].x][e[i].y]=sol[e[i].y][e[i].x]=1;	

		if(mp[e[i].x]==-14 || dist[e[i].x][mp[e[i].x]]<dist[e[i].x][e[i].y])
			mp[e[i].x]=e[i].y;

		if(mp[e[i].y]==-14 || dist[e[i].y][mp[e[i].y]]<dist[e[i].y][e[i].x])
			mp[e[i].y]=e[i].x;
	}

	ub=0.;

	for(i=0;i<n;i++)
		ub+=dist[i][mp[i]];

	printf("Initial solution: %f\n",ub);
}

double Cost()
{
	int j,i,k;
	double ub=0.;

	for(i=0;i<n;i++)
	{
		k=-14;
		for(j=0;j<n;j++)
			if(sol[i][j] && (k<0 || dist[i][k]<dist[i][j]))
				k=j;
		ub+=dist[i][k];
	}

	//printf("Conferma costo: %f\n",ub);
	return ub;
}


void SteepestDescent()
{
 	int i,j,jj,l,k,kk,kkk,oldi,oldj,conta;

	double oldub=ub;

	temp=0.;
	tub=bestub=ub;

	conta=0;
	
 	while(conta<200)
 	{
		conta++;
		
		if(conta>=NUMITER)
		{
			conta=0;
			temp/=QUOZIENTE;
		}

		// Salta k!
 		for(k=rand()%n,l=0;l<n && mp[k]<0;l++,k=((k+1)%n));

		if(l==n)
		{
			for(k=0;k<n;k++)
				printf("%d ",mp[k]);
			getchar();
		}

		sol[k][kk=mp[k]]=0;
		//printf("Tolgo %d %d\n",k,kk);
		// Risistemo k
		tub-=dist[k][kk];
		mp[k]=-14;
		for(l=0;l<n;l++)
		{
 			if(l!=k && sol[k][l] && (mp[k]==-14 || dist[k][mp[k]]<dist[k][l]))
				mp[k]=l; 		
		}
		if(mp[k]!=-14)
			tub+=dist[k][mp[k]];

		Raggiungib(k,kk); 
		
		if(nraga==0)
		{
		//	printf("Rigetto\n");
			goto rigettiamo;
		}
		//else
		//	printf("NON Rigetto\n");

		/* Meglio SENZA
		{
			double pago,pago2;
			pago=HIVAL;
			for(j=0;j<nraga;j++)
				if(raga[j]!=k)
				{
					pago2=dist[raga[j]][kk];
					if(mp[raga[j]]!=-14)
						pago2-=dist[raga[j]][mp[raga[j]]];
					if(pago>pago2)
					{
						pago=pago2;
						i=raga[j];
					}
				}
		}	
		*/

		i=raga[rand()%nraga];	
		oldi=mp[i];
		
		if(mp[i]==-14 || dist[i][kk] > dist[i][mp[i]])
		{		
			if(mp[i]!=-14)
				tub-=dist[i][mp[i]];
			mp[i]=kk;
			tub+=dist[i][kk];
		}		
		//printf("Metto %d %d\n",i,kk);
		//printf("Propongo %d-%d to %d-%d\n",k,kk,i,kk);
		//printf("Costo: %f %f %f\n",tub,ub,bestub);		
		if(tub<ub || ((rand()%1000)/1000.<exp(-(tub-ub)/(temp*B))))
		{
			//printf("Accepted\n");
			// Accepted
			sol[i][kk]=1;
			if(mp[i]==-14 || sol[i][mp[i]]<sol[i][kk])
				mp[i]=kk;
			if(mp[k]==-14)
				mp[k]=-1;
			ub=tub;
			if(tub<bestub-TOLL)
			{
				conta=0;
				bestub=tub;
				{
					int i,j;

					for(i=0;i<n;i++)
						for(j=0;j<n;j++)
							bestsol[i][j]=sol[i][j];
				}
				printf("Found %f\n",tub);
			}
//			for(i=0;i<n;i++,printf(" A\n"))
//		for(j=0;j<n;j++)
//			printf("%d ",sol[i][j]);
		}
		else
		{
rigettiamo:
			// Rejected
			//printf("Rejected\n");
			tub=ub;
			mp[i]=oldi;
			mp[k]=kk;
			sol[k][kk]=1;
//for(i=0;i<n;i++,printf(" R\n"))
//		for(j=0;j<n;j++)
//			printf("%d ",sol[i][j]);
		}
		for(i=0;i<n;i++)
			if(mp[i]==-14)
			{
				printf("%d %d | ",i,mp[i]);
				getchar();
			}

 	}
	printf("Improvement: %f \n",(oldub-bestub)/oldub);
}

int main(int argc, char* argv[])
{
	int iii;

	if(argc<3)
	{
		printf("%s <number of nodes> <random seed>\n",argv[0]);
		exit(14);
	}

	n = atoi(argv[1]);
	srand(atoi(argv[2]));

	DAS();
	exit(14);

	inittime=time(NULL);
	for(iii=0;iii<REP;iii++)
	{
		CreaRete();
		clock();
		CalcolaDist();
		CreaOrd();
		BIP();
		Sweep();
		//Prim();
		//BuildInitSol();
		Semplifica();
		SimulatedAnnealing_1();
	}

	return 14;
}

void SistemaSolution()
{
	int i,j;

	for(i=0;i<n;i++)
	{
		mp[i]=-1;
		for(j=0;j<n;j++)
			if(i!=j)
			{
				sol[i][j]=bestsol[i][j];
				if(sol[i][j] && (mp[i]==-1 || dist[i][mp[i]]<dist[i][j]))
					mp[i]=j;
				if(sol[i][j] && !dafare[i][j])
					printf("Ce effettivamente un problema\n");
			}
	}

	ub=bestub;
}

void Perturba()
// Perturbazione
{
	int i;

	for(i=0;i<n;i++)
	{
		if((mp[i]==0 || invord[i][mp[i]]!=n-2) && (rand()%1000<30/*0*/))
		{
			//printf("Da %f %d %d %d - ",dist[i][mp[i]],i,mp[i],invord[i][mp[i]]);
			if(mp[i]!=-1)
				ub-=dist[i][mp[i]];
			sol[i][(mp[i]=invord[i][mp[i]]+1)]=1;
			ub+=dist[i][mp[i]];
			//printf("a %f %d \n",dist[i][mp[i]],mp[i]);
			//getchar();
		}
	}
}

void DAS()
{
	int i,j,ii;
	char hole1[16],hole2[16],line[128];
	double tot=0.,tot2=0.,minn,minn2,oldub,oldub2;

	FILE *aprire,*scrivere;

	//n=4;

	scrivere=fopen("output","w");

	tottime=0.;
	for(i=0;i<10;i++)
	{
		printf("Iterazione = %d\n",i);
		for(j=0;j<150;j++)
		{
			nodi[j].x=(rand()%5000)/1000.;
			nodi[j].y=(rand()%5000)/1000.;
			printf("Nodo %f %f\n",nodi[j].x,nodi[j].y);
		}
		CalcolaDist();
		CreaOrd();
		minn=minn2=HIVAL;
		for(ii=0;ii<REP;ii++)
		{
		inittime=clock();

///* QUESTA VA BENE
			//STG();
			BIP();
//Sweep();
			if(ub<minn2)
				minn2=ub;

			oldub=ub;
			Perturba();

			printf("ub: %f\n",ub);
			//getchar();

			// !!!
			//oldub2=ub;
			//ub=oldub;
			// !!!

			Semplifica();
			
			// !!!
			//ub=oldub2;
			// !!!

			SimulatedAnnealing_1();		
			if(ub<minn2)
				minn2=ub;
			tottime+=(double)((parttime-inittime)/(1.*CLOCKS_PER_SEC));
			SistemaSolution();
			Sweep();
			if(ub<minn)
				minn=ub;
//*/

 /* BIP + SWEEP
			BIP();
			if(ub<minn2)
				minn2=ub;

			Sweep();
			if(ub<minn)
				minn=ub;	
 */
		}
		tot+=minn;
		tot2+=minn2;
		
		fprintf(scrivere, "%f\n",minn);
		//getchar();
	}
	printf("Average Simulated Annealing: %f \nAverage BIP+Sweep: %f\n",tot,tot2);
	printf("Average computation time: %f \n",tottime/(10.*REP));
	fclose(scrivere);
}


void DASDAFILE()
{
	int i,j,ii;
	char hole1[16],hole2[16],line[128];
	double tot=0.,tot2=0.,minn,minn2;

	FILE *aprire,*scrivere;

	//n=4;

	aprire=fopen("50instances_100node_source_1.dat","r");
	scrivere=fopen("output","w");

	tottime=tottime2=0.;
	for(i=0;i<50;i++)
	{
		printf("Iterazione = %d\n",i);
		for(j=0;j<100;j++)
		{
			fgets(line,100,aprire);
			sscanf(line,"%s %s\n",hole1,hole2);
			nodi[j].x=atof(hole1);
			nodi[j].y=atof(hole2);
			//printf("Nodo %f %f\n",nodi[j].x,nodi[j].y);
		}
		fgets(line,100,aprire);
		clock();
		CalcolaDist();
		CreaOrd();
		minn=minn2=HIVAL;
		for(ii=0;ii<REP;ii++)
		{
			inittime=clock();

///* QUESTA VA BENE
			//STG();
			BIP();
//Sweep();
			if(ub<minn2)
				minn2=ub;

			Perturba();

			//printf("ub: %f\n",ub);
			//getchar();
			Semplifica();

			SimulatedAnnealing_1();		
			tottime+=(double)((parttime-inittime)/(1.*CLOCKS_PER_SEC));
			SistemaSolution();
			Sweep();
//*/

 /* BIP + SWEEP
			BIP();
			if(ub<minn2)
				minn2=ub;

			Sweep();
			if(ub<minn)
				minn=ub;	
 */
			tottime2+=(double)((clock()-inittime)/(1.*CLOCKS_PER_SEC));
		}
		tot+=minn;
		tot2+=minn2;
		
		fprintf(scrivere, "%f\n",minn);
		//getchar();
	}
	printf("Average Simulated Annealing: %f \nAverage BIP+Sweep: %f\n",tot/50.,tot2/50.);
	printf("Average computation time: %f %f \n",(double)tottime/(50.*REP),(double)tottime2/(50.*REP));
	fclose(scrivere);
}

void CreaRete()
{
 int i;

 for(i=0;i<n;i++)
 {
	 nodi[i].x=rand()%DIMGRID;
	 nodi[i].y=rand()%DIMGRID;
	 
 }

return;
}

void CalcolaDist()
{
	int i,j;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			dist[i][j]=pow(sqrt(((nodi[i].x-nodi[j].x)*(nodi[i].x-nodi[j].x))+((nodi[i].y-nodi[j].y)*(nodi[i].y-nodi[j].y))),K);
}


void CreaOrd()
{
	int i,k,l,a,j;
	double act,old;


	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			if (i!=j)
			{
				old=0.;
				pred[i][j].x=pred[i][j].y=-14;
				act=pow(sqrt(((nodi[i].x-nodi[j].x)*(nodi[i].x-nodi[j].x))+((nodi[i].y-nodi[j].y)*(nodi[i].y-nodi[j].y))),K);
				for(k=0;k<n;k++)
				{
					if(i!=k && k!=j && ((pow(sqrt(((nodi[i].x-nodi[k].x)*(nodi[i].x-nodi[k].x))+((nodi[i].y-nodi[k].y)*(nodi[i].y-nodi[k].y))),K)==act && j<k) ||pow(sqrt(((nodi[i].x-nodi[k].x)*(nodi[i].x-nodi[k].x))+((nodi[
i].y-nodi[k].y)*(nodi[i].y-nodi[k].y))),K)<act) && pow(sqrt(((nodi[i].x-nodi[k].x)*(nodi[i].x-nodi[k].x))+((nodi[i].y-nodi[k].y)*(nodi[i].y-nodi[k].y))),K)>old)
					{
						old=pow(sqrt(((nodi[i].x-nodi[k].x)*(nodi[i].x-nodi[k].x))+((nodi[i].y-nodi[k].y)*(nodi[i].y-nodi[k].y))),K);
							pred[i][j].x=i;
							pred[i][j].y=k;
					}
				}
			}

	for(i=0;i<n;i++)
		for(a=-14,k=0;k<n-1;k++)
		{
			for(l=0;l<n;l++)
				if(l!=i && pred[i][l].y==a)
					break;
			ord[i][k]=a=l;
			invord[i][a]=k;
			//printf("%d %d - %d %d\n",i,k,ord[i][k],invord[i][a]);
		}
/*
	for(i=0;i<n;i++)
		for(k=0;k<n-1;k++)
			printf("%d %d %f\n",i,ord[i][k],dist[i][ord[i][k]]);
*/
}

bool Prim()
{
	int i,j,k;

	for(i=nx=0;i<n;i++)
		{
			k=i;
			x[nx++]=i;
			alfa[i]=-14;
			beta[i]=HIVAL*2;
		}
	beta[k]=0.;
	nu=ne=0;

	while(nx>0)
	{
		for(i=j=0;i<nx;i++)
			if(beta[x[i]]<beta[x[j]])
				j=i;
		if(alfa[x[j]]>=0)
		{
			if(dist[alfa[x[j]]][x[j]]>=HIVAL)
				return false;
			e[ne].x=alfa[x[j]];
			e[ne++].y=x[j];
		}
		u[nu++]=x[j];
		x[j]=x[--nx];
		for(i=0,j=u[nu-1];i<nx;i++)
			if(dist[j][x[i]]<beta[x[i]])
			{
				alfa[x[i]]=j;
				beta[x[i]]=dist[j][x[i]];
			}
	}

	for(i=0;i<ne;i++)
		printf("%d %d\n",e[i].x,e[i].y);
	return true;
}

void Semplifica()
{
	int i,j,k;
	int contata=0;
	double sum;

	//printf("ub: %f\n",ub);

///*
	// Modifica introdotta 25.12.03 Verificare che le prestazioni non ne risentano
	for(i=0;i<n;i++)
		for(k=0,j=n-2;j>=0;j--)
			if(!k)
			{
				bestsol[i][ord[i][j]]=sol[i][ord[i][j]];
				if(bestsol[i][ord[i][j]])
					k++;
				dafare[i][ord[i][j]]=1;
			}
			else
			{
				bestsol[i][ord[i][j]]=sol[i][ord[i][j]]=1;
				dafare[i][ord[i][j]]=1;
			}
//*/
/*
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
		{
			bestsol[i][j]=sol[i][j];
			dafare[i][j]=1;
		}
*/
	for(i=0;i<n;i++)
	{
		if(i!=0)
			sum=dist[0][ord[0][0]];
		else
			sum=0.;
		for(j=n-2;j>=0;j--)
		{	
			if((sum+dist[i][ord[i][j]])>ub+TOLL)
			{
			//	printf("sum: %f ub: %f\n",sum+dist[i][ord[i][j]]+dist[ord[i][j]][i]-dist[ord[i][j]][ord[ord[i][j]][0]],ub);
				contata++;
				dafare[i][ord[i][j]]=0;
//				printf("(%d %d) ",i,ord[i][j]);							
			}
		}
	}
			//printf("Calate %d su %d\n",contata,(n*(n-1)));
}
